import { downloadFile } from './processors';
import ExportType from './ExportType';
export interface IOption<R = void> {
    data: object | string;
    fileName?: string;
    extension?: string;
    fileNameFormatter?: (name: string) => string;
    fields?: string[] | Record<string, string>;
    exportType?: ExportType;
    replacer?: ((key: string, value: any) => any) | Array<number | string> | null;
    space?: string | number;
    processor?: (content: string, type: ExportType, fileName: string) => R;
    withBOM?: boolean;
    delimiter?: string;
    beforeTableEncode?: (tableRow: Array<{
        fieldName: string;
        fieldValues: string[];
    }>) => Array<{
        fieldName: string;
        fieldValues: string[];
    }>;
}
declare function exportFromJSON<R = void>({ data, fileName, extension, fileNameFormatter, fields, exportType, replacer, space, processor, withBOM, delimiter, beforeTableEncode, }: IOption<R>): R;
declare namespace exportFromJSON {
    const types: Record<ExportType, ExportType>;
    const processors: {
        downloadFile: typeof downloadFile;
    };
}
export default exportFromJSON;
